import ConfigParser, codecs
from random import random

class AggregatorConfig:
	def __init__ (self, localConfig='aggregator.ini'):
		self.config = {}
		self.readConfig(localConfig)
		self.dbEncoder=codecs.lookup(self.getValue ('global.characterset'))[0]
		self.dbDecoder=codecs.lookup(self.getValue ('global.characterset'))[1]
		
	def getValue (self, name):
		return self.config [name]
		
	def readConfig (self, localConfig):
		defaultPassword = []
		for a in xrange (0,10):
			defaultPassword.append (chr(int (random()*26) + ord('a')))
		defaultPassword = "".join (defaultPassword)
		self.fileConfig=ConfigParser.ConfigParser()
		self.fileConfig.read (['/etc/aggregator/aggregator.ini',localConfig])
		self.setValue ('global', 'user', 'agguser')
		self.setValue ('global', 'passwd', 'agguser')
		self.setValue ('global', 'db', 'aggdb')
		self.setValue ('global', 'characterset', 'latin1')
		
		self.setValue ('aggregator', 'loggingConfig', '/etc/aggregator/server_logging.ini')
		self.setValue ('aggregator', 'sleeptime', '60')
		self.setValue ('aggregator', 'numthreads', '2')
		
		self.setValue ('webclient', 'loggingConfig', '/etc/aggregator/client_logging.ini')
		self.setValue ('webclient', 'templatesDir', '/var/www/aggregator/templates/')
		self.setValue ('webclient', 'adminUsername', 'admin')
		# Use a random password for the admin if none has been specified.
		self.setValue ('webclient', 'adminPassword', defaultPassword)
		
	def setValue (self, section, name, defaultValue):
		if (self.fileConfig.has_option (section, name)):
			self.config ['%s.%s' % (section,name)] = self.fileConfig.get (section,name)
		else:
			self.config ['%s.%s' % (section,name)] = defaultValue
			
	def dbToUnicode (self, astring):
		if (astring is None):
			return None
		return self.dbDecoder (astring, 'replace')[0]
		
	def unicodeToDb (self, astring):
		if (astring is None):
			return None
		return self.dbEncoder (astring, 'replace')[0]
