CREATE TABLE agg_users
  (user_id      INT(10) NOT NULL AUTO_INCREMENT
  ,userName     VARCHAR(250) NOT NULL 
  ,password     VARCHAR(50)  NOT NULL
  ,PRIMARY KEY (user_id)
  ,UNIQUE INDEX (userName)
  );
  
CREATE TABLE agg_users_templates
 (template_id  INT(10) NOT NULL AUTO_INCREMENT
 ,user_id      INT(10)
 ,templateFile VARCHAR(250) NOT NULL
 ,numEntries   INT(10) NOT NULL DEFAULT 25
 ,PRIMARY KEY (template_id)
 );
  
CREATE TABLE agg_feeds
  (feed_id        INT(10) NOT NULL AUTO_INCREMENT
  ,feed_url       VARCHAR(250) NOT NULL
  ,checkFrequency INT(10) NOT NULL
	,nextCheck		  DATETIME
  ,PRIMARY KEY (feed_id)
  ,UNIQUE INDEX (feed_url)
  );
  
CREATE TABLE agg_user_feeds
	(user_id          INT(10) NOT NULL
	,feed_id          INT(10) NOT NULL
	,userLabel        VARCHAR(250)
	,subscriptionDate DATETIME 
	,PRIMARY KEY (user_id, feed_id)
	);
	
CREATE TABLE agg_feed_details
  (feed_id         INT(10) NOT NULL
  ,title					 VARCHAR(250)
  ,lastUpdate		  DATETIME
  ,imageURL 			 VARCHAR(250)
  ,imageTitle      VARCHAR(250)
  ,imageLink			 VARCHAR(250)
  ,channelLink		 VARCHAR(250)
  ,channelDesc		 LONGTEXT
  ,htmlChannelDesc LONGTEXT
  ,language			  VARCHAR(50)
  ,goodXML				 VARCHAR(1)
  ,PRIMARY KEY (feed_id)
  );
  
CREATE TABLE agg_articles
  (article_id 		 INT(10) NOT NULL AUTO_INCREMENT
  ,feed_id				 INT(10) NOT NULL
  ,articleDate		 DATETIME NOT NULL
  ,discoveryDate	 DATETIME NOT NULL
  ,title					 VARCHAR(250)
  ,description 	  LONGTEXT
  ,htmlDescription LONGTEXT
  ,link					  VARCHAR(250)
  ,guid			      VARCHAR(250)
  ,fingerPrint		 VARCHAR(250)
  ,firstFeedFlag	 CHAR(1) DEFAULT 'N'
  ,PRIMARY KEY (article_id)
  ,INDEX (articleDate)
  ,INDEX (feed_id)
  ,INDEX (fingerPrint)
  );
  
